import geometry;

//-----------------------------------------------------------
// Définition des doubles fléches pour les asymptotes
//
arrowbar DoubleArrow(arrowhead arrowhead=DefaultHead,
real size=0, real angle=arrowangle,
filltype filltype=null)
{
return new bool(picture pic, path g, pen p, margin margin) {
add(pic,arrow(arrowhead,g,p,size,angle,filltype,margin));
real pos1=arclength(g);
real pos=1-0.08/pos1;
add(pic,arrow(arrowhead,g,p,size,angle,filltype,position=Relative(pos),margin));
return false;
};
}
//------------
arrowbar DoubleArrow=DoubleArrow();
//------------
arrowbar DoubleArrows(arrowhead arrowhead=DefaultHead,
real size=0, real angle=arrowangle,
filltype filltype=null)
{
return new bool(picture pic, path g, pen p, margin margin) {
add(pic,arrow2(arrowhead,g,p,size,angle,filltype,margin));
real coef1=1-0.08/arclength(g);
add(pic,arrow(arrowhead,g,p,size,angle,filltype,position=Relative(coef1),margin));

add(pic,arrow(arrowhead,g,p,size,angle,filltype,position=Relative(1-coef1),
forwards=false,margin));
return false;
};
}
//--------------
arrowbar DoubleArrows=DoubleArrows();
//--------------

//----------------------------------------------------------------------
void graduationstatx(real xmin,real xmax,real ymin,real ymax,real dx,real dy,real carx)
// graduations horizontales
//
{
  real val;
  int k;
  k=round(xmin/carx);
  val=k*carx;
  if (val < xmin)
  {
    k=k+1;
    val=k*carx;
  }  
  do
  {
        label(format("%.2f",val),shift(0,-0.1*dy)*(val,ymin),S);
        draw(shift(0,-0.1*dy)*(val,ymin) --shift(0,0.1*dy)*(val,ymin));
	k=k+1;
	val=k*carx;
  }while(val<=xmax);
}
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// graduations verticales
//
void graduationstaty(real xmin,real xmax,real ymin,real ymax,real dx,real dy,real cary)
{
  real val;
  int k;
  k=round(ymin/cary);
  val=k*cary;
  if (val < ymin)
  {
    k=k+1;
    val=k*cary;
  }  
  do{
        label(format("%.2f",val),shift(-0.1*dx,0)*(xmin,val),W);
        draw(shift(-0.1*dx,0)*(xmin,val) -- shift(0.1*dx,0)*(xmin,val));
	k=k+1;
	val=k*cary;
  }while(val<=ymax);
}

//----------------------------------------------------------------------
// grille horizontale
//
void grillehori(real xmin,real xmax,real ymin,real ymax,real gradx,pen col,pen trait)
{
  real val;
  int k;

  k=round(ymin/gradx);
  val=k*gradx;
  if (val < ymin)
  {
    k=k+1;
    val=k*gradx;
  }    
  do 
  {
     draw((xmin,val)--(xmax,val),col+1.bp+trait);
	  k=k+1;
	  val=k*gradx;
  } while(val <= ymax);
}



//----------------------------------------------------------------------
// grille verticale
//
void grilleverti(real xmin,real xmax,real ymin,real ymax,real grady,pen col,pen trait)
{
  real val;
  int k;
  k=round(xmin/grady);
  val=k*grady;
  if (val < xmin)
  {
    k=k+1;
    val=k*grady;
  } 
  do
  {
     draw((val,ymin)--(val,ymax),col+1.bp+trait);
	  k=k+1;
	  val=k*grady;
  }while(val <=xmax);
}



//----------------------------------------------------------------------
// marquage des points
//
void marquecroix(point p,real dx,real dy,pen col)
{
 draw (shift(-0.1*dx,0.1*dy)*p--shift(0.1*dx,-0.1*dy)*p,col);
 draw (shift(-0.1*dx,-0.1*dy)*p--shift(0.1*dx,0.1*dy)*p,col);
}

//----------------------------------------------------------------------
// Style de lignes hachurées
//
pen smalldashed=linetype("4 4");

